=== man/CMakeLists.txt ===
add_custom_target(man ALL DEPENDS adoc_man man_man)

add_subdirectory(adoc)
add_subdirectory(man8)
