=== src/arch/CMakeLists.txt ===
add_library(arch STATIC
  arm.cpp
  ppc64.cpp
  s390.cpp
  arch.cpp
  x86_64.cpp
  mips64.cpp
  riscv64.cpp
  loongarch64.cpp
)
