=== src/debugfs/CMakeLists.txt ===
add_library(debugfs STATIC
  debugfs.cpp
  )
