=== src/tracefs/CMakeLists.txt ===
add_library(tracefs STATIC
  tracefs.cpp
  )
