=== debian/changelog ===
bpftrace (0.24.1-1) unstable; urgency=medium

  * New upstream release.
  * d/control: build-depend on xxd.
  * d/examples: remove (examples are not shipped anymore).

 -- Vincent Bernat <bernat@debian.org>  Sun, 05 Oct 2025 10:22:48 +0200
